import { createHead } from '@unhead/vue'

import App from './App.vue'
import AppLoading from './AppLoading.vue'

import './styles'
import { setupPinia } from './modules/pinia'
import { setupI18n } from './modules/i18n'
import { initRouter, setupRouterGuards } from './modules/router/router'
import { setupPWA } from './modules/pwa'
import 'virtual:svg-icons-register'

let meta = document.createElement('meta')
meta.name = 'naive-ui-style'
document.head.appendChild(meta)

meta = document.createElement('meta')
meta.name = 'vueuc-style'
document.head.appendChild(meta)

; (async () => {
  // TODO loadingApp
  const appLoading = createApp(AppLoading)
  // setupPinia(appLoading)
  // setup I18n
  // await setupI18n(appLoading)
  appLoading.mount('#appLoading')

  const app = createApp(App)
  setupPinia(app)

  // initApplication
  app.use(createHead())

  // setup I18n
  await setupI18n(app)

  // Router
  const router = await initRouter(import.meta.env.VITE_BASE_URL)
  app.use(router)
  // Router guards
  await setupRouterGuards()
  await router.isReady()

  // pwa
  await setupPWA()

  // mount
  app.mount('#app')
  // TODO MOCK
})()
